%     FASTENER DOCTOR - программа для лечения и конвертации крепежа
%     Copyright (C) 2018  Михаил Козлов
%     Сайт проекта: <http://www.fastenerdoctor.ru/>
%     Адрес электронной почты для связи с разработчиком:
%     <doctor.fastener@gmail.com>
% 
%     Эта программа является свободным программным обеспечением: Вы можете
%     распространять ее и/или изменять, соблюдая условия Универсальной общественной
%     лицензии GNU, опубликованной Фондом свободного программного обеспечения,
%     либо редакции 3, либо (на Ваше усмотрение) любой редакции, выпущенной позже.
% 
%     Эта программа распространяется в надежде на то, что она окажется полезной,
%     но БЕЗ КАКИХ-ЛИБО ГАРАНТИЙ, включая даже подразумеваемую гарантию ТОВАРНОЙ ПРИГОДНОСТИ,
%     либо ПРИГОДНОСТИ ДЛЯ ОПРЕДЕЛЕННЫХ ЦЕЛЕЙ. Ознакомьтесь с Универсальной общественной
%     лицензией GNU для получения более подробной информации.
% 
%     Вы должны были получить копию Универсальной общественной лицензии GNU
%     вместе с этой программой. Если Вы ее не получили, то перейдите по адресу:
%     <http://www.gnu.org/licenses/>.
% 
%     This program is free software: you can redistribute it and/or modify
%     it under the terms of the GNU General Public License as published by
%     the Free Software Foundation, either version 3 of the License, or
%     (at your option) any later version.
% 
%     This program is distributed in the hope that it will be useful,
%     but WITHOUT ANY WARRANTY; without even the implied warranty of
%     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
%     GNU General Public License for more details.
% 
%     You should have received a copy of the GNU General Public License
%     along with this program.  If not, see <https://www.gnu.org/licenses/>.

function Test_Result = Fast_General_Coord_Test(Coord_ID, Axis_Point_1, Axis_Point_2, Axis_vector, CM_Coord_list)

% Тест системы координат на пригодность в качестве общей СК болта

global DB_COORD;
global AT_COORD;

global Coord_Origin_Bolt_Dist_tolerance;
global Coord_Z_Bolt_Axis_deg_tolerance;

Test_Result = 0;

% Заполнение атрибутов СК
if (Coord_ID == 0)
    
    Coord_type = 'Rectangular';
    Coord_origin = [0;0;0];
    Coord_e_z = [0;0;1];
    
else
    
    Coord_type = DB_COORD{AT_COORD(Coord_ID)}.type;
    Coord_origin = DB_COORD{AT_COORD(Coord_ID)}.origin;
    Coord_e_z = DB_COORD{AT_COORD(Coord_ID)}.e_z;
    
end

% Тест на тип СК
if (~strcmp(Coord_type, 'Rectangular'))
    
    Test_Result = -1;
    return;
    
end

% Тест на расположение начала СК на оси болта
if (Get_Point_Line_Distance(Coord_origin, Axis_Point_1, Axis_Point_2) > Coord_Origin_Bolt_Dist_tolerance)
    
    Test_Result = -1;
    return;
    
end

% Тест на сонаправленность оси Z с осью болта
Angle = acosd(dot(Coord_e_z, Axis_vector)); % Вектора имеют единичную длину

if (Angle > 90)
    Angle = 180 - Angle;
end

if (Angle > Coord_Z_Bolt_Axis_deg_tolerance)
    
    Test_Result = -1;
    return;
    
end

% Тест на то, что СК не используется для задания ориентации CBUSH элементов, моделирующих смятие в композите
if (ismember(Coord_ID, CM_Coord_list))
    
    Test_Result = -1;
    return;
    
end
